/***************************************************************************
 * @COPYRIGHT NOTICE
 * @Copyright 2023 Horizon Robotics, Inc.
 * @All rights reserved.
 * @Date: 2023-03-05 15:28:19
 * @LastEditTime: 2023-03-05 16:31:05
 ***************************************************************************/
/***************************************************************************
 * @COPYRIGHT NOTICE
 * @Copyright 2023 Horizon Robotics, Inc.
 * @All rights reserved.
 * @Date: 2023-01-30 11:27:41
 * @LastEditTime: 2023-03-05 14:15:22
 ***************************************************************************/
#ifndef VP_COMMONH_
#define VP_COMMONH_

#include <stdint.h>

#if defined J5
#define SDK_SOC J5
#elif defined X3
#define SDK_SOC X3
#endif

#define SDK_MAX_PATH_LENGTH 128
#define SDK_MAX_FILES_NUM 128

#define SDK_MAX_JSON_DEPTH 10
#define SDK_MAX_FIELD_LENGTH 20
#define SDK_MAX_CMD_LENGTH 128
#define SDK_MAX_RESULT_LENGTH 1024
#define SDK_MAX_SENSOR_NAME 10

#if defined X3
#define SDK_MAX_PIPELINE_NUM 8
#define SDK_PIPELINE_MASK 0xffffff00
#define SDK_CODEC_MASK 0x00000000
#define VPP_DISPLAY_MASK 0xfffffffe
#elif defined J5
#define SDK_MAX_PIPELINE_NUM 16
#define SDK_PIPELINE_MASK 0xffff0000
#define SDK_CODEC_MASK 0x00000000
#define VPP_DISPLAY_MASK 0xfffffffc
#endif
#if defined J5
#define SDK_CAMERA_CFG_PATH "/etc/camera_configs/Ultra/"
#define SDK_SPDEV_CFG_PATH "/etc/spdev/Ultra/"
#elif defined X3
#define SDK_CAMERA_CFG_PATH "/etc/camera_configs/" SDK_SOC "/"
#define SDK_SPDEV_CFG_PATH "/etc/spdev/" SDK_SOC "/"
#endif

#define SDK_PATTERN_NAME "pattern"

#define SDK_CAM_CFG_NAME "cam.json"
#if defined X3
#define SDK_VIO_CFG_NAME "vio.json"
#elif defined J5
#define SDK_VIO_CFG_NAME "vpm.json"
#endif

#define SDK_DISPLAY_NAME "display"
#define SDK_DISPLAY_CFG_NAME "display.json"
#define SDK_DISPLAY_MIPITX_CFG_NAME "display_cam.json"

#if defined X3
#define SDK_FONT_HZK16_FILE "/etc/vio/HZK16"
#define SDK_FONT_ASC16_FILE "/etc/vio/ASC16"
#elif defined J5
#define SDK_FONT_HZK16_FILE SDK_SPDEV_CFG_PATH "/" SDK_DISPLAY_NAME "/" "/HZK16"
#define SDK_FONT_ASC16_FILE SDK_SPDEV_CFG_PATH "/" SDK_DISPLAY_NAME "/" "/ASC16"
#endif

#define SDK_GET_FRAME_TIMEOUT 3000

enum {
    SDK_AI_SENSOR,
};

typedef struct {
    int32_t width;
    int32_t height;
    int32_t stride;

    int64_t frame_id;
    int64_t lost_image_num;
    int64_t exp_time;
    int64_t image_timestamp;
    int32_t plane_count;

    uint8_t *data[2];
    uint64_t pdata[2];
    uint32_t data_size[2];
    void *frame_info;
} ImageFrame;

#endif // VP_COMMONH_